--
-- Patch DDL de GRHUM du 26/03/2012 à exécuter depuis le user GRHUM
--
-- Rem : fichier encodé UTF-8

SET DEFINE OFF;

--
--
-- Fichier : 1
-- Type : DDL
-- Schema : GRHUM
-- Numero de version : 1.7.1.6
-- Date de publication : 26/03/2012
-- Auteur(s) : Cocktail
-- Licence : CeCILL version 2
--
--

WHENEVER SQLERROR EXIT SQL.SQLCODE;


--
-- DB_VERSION
--
-- Rem : test de l'existence de la version précédente
declare
cpt integer;
begin
	select count(*) into cpt from grhum.db_version where dbv_libelle='1.7.1.5';
    if cpt = 0 then
        raise_application_error(-20000,'Le user GRHUM n''est pas à jour pour passer ce patch !');
    end if;
end;
/



-- 
-- CATEGORIE_EMPLOI_LOLF
--
CREATE TABLE GRHUM.CATEGORIE_EMPLOI_LOLF (
  CEML_ORDRE       	number(8) NOT NULL,
  CEML_CODE			varchar2(4) NOT NULL,  
  CEML_LC			varchar2(10), 
  CEML_LL 			varchar2(40),
  D_OUVERTURE     DATE,
  D_FERMETURE     DATE,
  D_CREATION      DATE                          NOT NULL,
  D_MODIFICATION  DATE                          NOT NULL,
  CONSTRAINT PK_CATEGORIE_EMPLOI_LOLF 
    PRIMARY KEY (CEML_ORDRE));
	
COMMENT ON TABLE GRHUM.CATEGORIE_EMPLOI_LOLF IS 'Table de nomenclature issue de la BCN qui recense les catégories d''emplois LOLF.';
COMMENT ON COLUMN GRHUM.CATEGORIE_EMPLOI_LOLF.CEML_ORDRE IS 'Clef primaire de la table CATEGORIE_EMPLOI_LOLF.';
COMMENT ON COLUMN GRHUM.CATEGORIE_EMPLOI_LOLF.CEML_CODE IS 'Code de la catégorie d''emploi LOLF.';
COMMENT ON COLUMN GRHUM.CATEGORIE_EMPLOI_LOLF.CEML_LC IS 'Libellé du court de la catégorie d''emploi LOLF.';
COMMENT ON COLUMN GRHUM.CATEGORIE_EMPLOI_LOLF.CEML_LL IS 'Libellé du long de la catégorie d''emploi LOLF.';
COMMENT ON COLUMN GRHUM.CATEGORIE_EMPLOI_LOLF.D_OUVERTURE IS 'Date d''ouverture de la catégorie d''emploi LOLF.';
COMMENT ON COLUMN GRHUM.CATEGORIE_EMPLOI_LOLF.D_FERMETURE IS 'Date de fermeture de la catégorie d''emploi LOLF.';
COMMENT ON COLUMN GRHUM.CATEGORIE_EMPLOI_LOLF.D_CREATION IS 'Date de création de la catégorie d''emploi LOLF.';
COMMENT ON COLUMN GRHUM.CATEGORIE_EMPLOI_LOLF.D_MODIFICATION IS 'Date de modification de la catégorie d''emploi LOLF.';

-- Sequences GRHUM_PARAMETRES_TYPES
CREATE SEQUENCE GRHUM.CATEGORIE_EMPLOI_LOLF_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE NOORDER;

-- GRANT
GRANT SELECT, REFERENCES ON GRHUM.CATEGORIE_EMPLOI_LOLF TO MANGUE;



--
-- PERSONNE_TELEPHONE
--
ALTER TABLE GRHUM.PERSONNE_TELEPHONE DROP CONSTRAINT CKD_TYPE_TEL;
ALTER TABLE GRHUM.PERSONNE_TELEPHONE DROP CONSTRAINT CKD_TYPE_NO;



--
-- CORPS
--
ALTER TABLE GRHUM.CORPS ADD TEM_LOCAL CHAR(1) DEFAULT('N') NOT NULL;

ALTER TABLE GRHUM.CORPS ADD (CONSTRAINT CHK_CORPS_TEM_LOCAL CHECK ((TEM_LOCAL IN ('O','N'))));

COMMENT ON COLUMN GRHUM.CORPS.TEM_LOCAL IS 'Témoin indiquant s''il s''agit d''une nomenclature locale ( ''O''ui ou ''N''on )';



--
-- GRADE
--
ALTER TABLE GRHUM.GRADE ADD TEM_LOCAL CHAR(1) DEFAULT('N') NOT NULL;

ALTER TABLE GRHUM.GRADE ADD (CONSTRAINT CHK_GRADE_TEM_LOCAL CHECK ((TEM_LOCAL IN ('O','N'))));

COMMENT ON COLUMN GRHUM.GRADE.TEM_LOCAL IS 'Témoin indiquant s''il s''agit d''une nomenclature locale ( ''O''ui ou ''N''on )';



--
-- INDICE
--
ALTER TABLE GRHUM.INDICE ADD TEM_LOCAL CHAR(1) DEFAULT('N') NOT NULL;

ALTER TABLE GRHUM.INDICE ADD (CONSTRAINT CHK_INDICE_TEM_LOCAL CHECK ((TEM_LOCAL IN ('O','N'))));

COMMENT ON COLUMN GRHUM.INDICE.TEM_LOCAL IS 'Témoin indiquant s''il s''agit d''une nomenclature locale ( ''O''ui ou ''N''on )';



--
-- PASSAGE_ECHELON
--
ALTER TABLE GRHUM.PASSAGE_ECHELON ADD TEM_LOCAL CHAR(1) DEFAULT('N') NOT NULL;

ALTER TABLE GRHUM.PASSAGE_ECHELON ADD (CONSTRAINT CHK_PASS_ECH_TEM_LOCAL CHECK ((TEM_LOCAL IN ('O','N'))));

COMMENT ON COLUMN GRHUM.PASSAGE_ECHELON.TEM_LOCAL IS 'Témoin indiquant s''il s''agit d''une nomenclature locale ( ''O''ui ou ''N''on )';



--
-- TYPE_CONTRAT_TRAVAIL
--
ALTER TABLE GRHUM.TYPE_CONTRAT_TRAVAIL ADD TEM_LOCAL CHAR(1) DEFAULT('N') NOT NULL;

ALTER TABLE GRHUM.TYPE_CONTRAT_TRAVAIL ADD (CONSTRAINT CHK_TYP_CTR_TRAV_TEM_LOCAL CHECK ((TEM_LOCAL IN ('O','N'))));

COMMENT ON COLUMN GRHUM.TYPE_CONTRAT_TRAVAIL.TEM_LOCAL IS 'Témoin indiquant s''il s''agit d''une nomenclature locale ( ''O''ui ou ''N''on )';



--
-- Ins_Individu_Ulr
--
CREATE OR REPLACE PROCEDURE GRHUM.Ins_Individu_Ulr
(
INS_NOM_PATRONYMIQUE         INDIVIDU_ULR.nom_patronymique%TYPE,
INS_PRENOM                   INDIVIDU_ULR.prenom%TYPE,
INS_C_CIVILITE               INDIVIDU_ULR.c_civilite%TYPE,
INS_NOM_USUEL                INDIVIDU_ULR.nom_usuel%TYPE,
INS_PRENOM2                  INDIVIDU_ULR.prenom2%TYPE,
INS_D_NAISSANCE        		 INDIVIDU_ULR.d_naissance%TYPE,
INS_VILLE_DE_NAISSANCE       INDIVIDU_ULR.ville_de_naissance%TYPE,
INS_C_DEPT_NAISSANCE         INDIVIDU_ULR.c_dept_naissance%TYPE,
INS_C_PAYS_NAISSANCE         INDIVIDU_ULR.c_pays_naissance%TYPE,
INS_C_PAYS_NATIONALITE       INDIVIDU_ULR.c_pays_nationalite%TYPE,
INS_D_NATURALISATION         INDIVIDU_ULR.d_naturalisation%TYPE,
INS_D_DECES                  INDIVIDU_ULR.d_deces%TYPE,
INS_IND_C_SIT_MILITAIRE      INDIVIDU_ULR.ind_c_sit_militaire%TYPE,
INS_IND_C_SITUATION_FAMILLE  INDIVIDU_ULR.ind_c_situation_famille%TYPE,
INS_IND_NO_INSEE             INDIVIDU_ULR.ind_no_insee%TYPE,
INS_IND_CLE_INSEE            INDIVIDU_ULR.ind_cle_insee%TYPE,
INS_IND_QUALITE              INDIVIDU_ULR.ind_qualite%TYPE,
INS_IND_ACTIVITE             INDIVIDU_ULR.ind_activite%TYPE,
INS_IND_ORIGINE              INDIVIDU_ULR.ind_origine%TYPE,
INS_IND_PHOTO                INDIVIDU_ULR.ind_photo%TYPE,
persid						 OUT NUMBER,
noindividu					 OUT NUMBER
)
-- Auteur : Cocktail
-- modification : 15/02/2012
-- prise en compte des attributs pers_id_creation et pers_id_modification
IS

cpt                 INTEGER;
new_INS_D_NAISSANCE DATE;
cpaysnaissance		INDIVIDU_ULR.c_pays_naissance%TYPE;
cpaysnationalite	INDIVIDU_ULR.c_pays_nationalite%TYPE;
photo               VARCHAR2(100);
persIdGRHUM         INTEGER;

BEGIN

-- recuperation d'un pers_id de GRHUM_CREATEUR
SELECT PERS_ID into persIdGRHUM FROM COMPTE WHERE CPT_LOGIN=(SELECT MIN(PARAM_VALUE) FROM GRHUM_PARAMETRES WHERE PARAM_KEY='GRHUM_CREATEUR');

-- vérification des chaines de caractères
IF ((INS_D_NAISSANCE IS NOT NULL) AND (LENGTH(TO_CHAR(INS_D_NAISSANCE,'DD/MM/YYYY')) <> 10)) THEN
   RAISE_APPLICATION_ERROR(-20000,'Ins_Individu_Ulr : INS_D_NAISSANCE ('||INS_D_NAISSANCE||') pas au format : JJ/MM/AAAA');
END IF;

IF (INS_D_NAISSANCE IS NULL) THEN
   new_INS_D_NAISSANCE:=TO_DATE('01/01/2001','dd/mm/yyyy');
ELSE
	new_INS_D_NAISSANCE:=INS_D_NAISSANCE;
END IF;

IF ((INS_C_DEPT_NAISSANCE IS NOT NULL) AND (INS_C_PAYS_NAISSANCE IS NULL))
THEN RAISE_APPLICATION_ERROR(-20000,'INS_INDIVIDU_ULR : Il faut un PAYS de NAISSANCE');
END IF;

-- Modif. le 29/10/04 : par défaut le pays de naissance est la France
IF (INS_C_PAYS_NAISSANCE IS NULL) THEN
   cpaysnaissance := '100';
ELSE
	cpaysnaissance := INS_C_PAYS_NAISSANCE;
END IF;

-- Idem pour le pays de nationalite
IF (INS_C_PAYS_NATIONALITE IS NULL) THEN
   cpaysnationalite := '100';
ELSE
	cpaysnationalite := INS_C_PAYS_NATIONALITE;
END IF;

-- Test HOMONYMIE faite par le trigger "trg_br_individu_ulr"

IF (INS_IND_PHOTO IS NULL) THEN
   photo:='N';
ELSE
	photo:=INS_IND_PHOTO;
END IF;

-- Clefs primaires
SELECT SEQ_INDIVIDU_ULR.NEXTVAL INTO noindividu FROM dual;

SELECT SEQ_PERSONNE.NEXTVAL INTO persid FROM dual;


INSERT INTO INDIVIDU_ULR
(
NO_INDIVIDU,
PERS_ID,
NOM_PATRONYMIQUE,
PRENOM,
C_CIVILITE,
NOM_USUEL,
PRENOM2,
D_NAISSANCE,
VILLE_DE_NAISSANCE,
C_DEPT_NAISSANCE,
C_PAYS_NAISSANCE,
C_PAYS_NATIONALITE,
D_NATURALISATION,
D_DECES,
IND_C_SIT_MILITAIRE,
IND_C_SITUATION_FAMILLE,
IND_NO_INSEE,
IND_CLE_INSEE,
IND_QUALITE,
IND_PHOTO,
IND_ACTIVITE,
IND_ORIGINE,
D_CREATION,
D_MODIFICATION,
TEM_SS_DIPLOME,
TEM_VALIDE,
IND_AGENDA,
LANGUE_PREF,
LISTE_ROUGE,
NOM_AFFICHAGE,
PRENOM_AFFICHAGE,
PERS_ID_CREATION,
PERS_ID_MODIFICATION
)
VALUES
(
noindividu,
persid,
UPPER(LTRIM(RTRIM(INS_NOM_PATRONYMIQUE))),
UPPER(LTRIM(RTRIM(INS_PRENOM))),
INS_C_CIVILITE,
UPPER(LTRIM(RTRIM(INS_NOM_USUEL))),
UPPER(LTRIM(RTRIM(INS_PRENOM2))),
new_INS_D_NAISSANCE,
INS_VILLE_DE_NAISSANCE,
INS_C_DEPT_NAISSANCE,
cpaysnaissance,
cpaysnationalite,
INS_D_NATURALISATION,
INS_D_DECES,
INS_IND_C_SIT_MILITAIRE,
INS_IND_C_SITUATION_FAMILLE,
INS_IND_NO_INSEE,
INS_IND_CLE_INSEE,
INS_IND_QUALITE,
photo,
INS_IND_ACTIVITE,
INS_IND_ORIGINE,
SYSDATE,
SYSDATE,
'O',
'O',
'N',
'fr',	-- langue_pref
'N',    -- liste_rouge
LTRIM(RTRIM(INS_NOM_USUEL)),	   -- Nom d'affichage
LTRIM(RTRIM(INS_PRENOM)), 		   -- Prenom d'affichage
persIdGRHUM,
persIdGRHUM
);

END;
/



COMMIT;
